<template>
  <div class="m-character" v-if="isLoadedData">
    <div class="m-character__stats m-character-stats">
      <m-character-stats-table-stats
        :stats="stats"
        :immutable-stats="immutableStats"
        @caculate="handleUpdateAvailablePoints"
        @save="handleSavePoints"
        @reset="handleResetPoints"
      />
    </div>

    <div class="m-character__information m-character-information">
      <m-character-stats-table-information
        :stats="stats"
        :immutable-stats="immutableStats"
      />
    </div>
  </div>
</template>

<script>
import {
  findStatsCharacterByUsername,
  updateStatsCharacterByUsername,
  resetStatsCharacterByUsername,
} from "../api/charecter.js";
import "../scss/m-character.scss";

import MCharacterStatsTableStats from "./MCharacterStatsTableStats.vue";
import MCharacterStatsTableInformation from "./MCharacterStatsTableInformation.vue";

export default {
  name: "MCharacterPanel",
  components: {
    MCharacterStatsTableStats,
    MCharacterStatsTableInformation,
  },
  props: {
    username: {
      type: String,
      required: true,
    },
  },
  data() {
    return {
      stats: {},
      immutableStats: {},
      isLoadedData: false,
    };
  },
  created() {
    findStatsCharacterByUsername(this.username)
      .then((stats) => {
        this.updateStats(stats);
      })
      .catch((errorMessage) => {
        alert(errorMessage);
      })
      .finally(() => {
        this.isLoadedData = true;
      });
  },
  methods: {
    handleSavePoints() {
      updateStatsCharacterByUsername(this.username, {
        intelligence: this.stats.intelligence,
        dexterity: this.stats.dexterity,
        vitality: this.stats.vitality,
        strength: this.stats.strength,
      })
        .then((newStats) => {
          this.updateImmutableStats(newStats);
        })
        .catch((errorMessage) => {
          alert(errorMessage);
        });
    },
    handleResetPoints() {
      resetStatsCharacterByUsername(this.username)
        .then((stats) => {
          this.updateStats(stats);
        })
        .catch((errorMessage) => {
          alert(errorMessage);
        });
    },
    handleUpdateAvailablePoints(points) {
      this.stats.available_points = points;
    },
    updateImmutableStats(stats) {
      this.immutableStats = { ...stats };
    },
    updateStats(stats) {
      this.stats = stats;
      this.updateImmutableStats(stats);
    },
  },
};
</script>